﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;
using System.IO;
using System.Drawing;

public partial class _Default : System.Web.UI.Page 
{
	/// <summary>
	/// Cache 및 Session 에 저장될 자격인증 키값
	/// </summary>
	private static readonly string PARAM_CREDENTIALS_CACHE	= "C";
	private Uri thisUri	= null;

    protected void Page_Load(object sender, EventArgs e)
    {	
		if( IsPostBack ) return;

		txtFtp.Text		= "FTP://umc.pe.kr:5830/www/r.txt";
    }
	protected void btnConnection_Click(object sender, EventArgs e)
	{
		WebClient client		= new WebClient();
		thisUri					= new Uri( txtFtp.Text );

		try
		{
			lblCache.Text = lblData.Text	= string.Empty;
			lblCache.ForeColor				= Color.Red;

			// Cache 및 Session 에 저장된 자격인증이 있는지 검사한다.
			if (Cache[PARAM_CREDENTIALS_CACHE] == null)
			{
				NetworkCredential ct			= new NetworkCredential(txtID.Text, txtPassword.Text);
				client.Credentials				= ct;
				Cache[PARAM_CREDENTIALS_CACHE]	= ct;

				lblCache.Text					= "Create Credential";
			}
			else
			{
				client.Credentials				= (NetworkCredential)Cache[PARAM_CREDENTIALS_CACHE];
				lblCache.Text					= "Cache Credential";
				lblCache.ForeColor				= Color.Blue;
			}

			byte[] bData = client.DownloadData(txtFtp.Text);
			string sData = System.Text.Encoding.Default.GetString(bData);

			lblData.Text = sData;
		}
		catch (WebException)
		{
			btnCacheClear_Click(this, EventArgs.Empty);
			lblCache.Text		= "경로가 틀리거나, 인증되지 않았습니다";
		}
	}
	protected void btnCacheClear_Click(object sender, EventArgs e)
	{
		// Cache 또는 Session 에 저장된 자격인증을 제거한다.
		Cache.Remove( PARAM_CREDENTIALS_CACHE );

		lblCache.Text			= "Clear Cache";
		lblCache.ForeColor		= Color.Black;
	}
}
